/*
 * (C) Copyright IBM Corp. 1997-1998  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.parser;

/**
 * An Interface listening errors.
 *
 * @version 19980206
 * @author TAMURA Kent &lt;kent@trl.ibm.co.jp&gt;
 */

public interface ErrorListener {
    /**
     * This method is called by Parser when some error occurs.
     * <p><strong>Note:</strong> You must not trust <i>lineno</i> and <i>charoff</i> when
     * input stream includes invalid octet as its encoding.
     * <i>key</i> is an instance of <code>sun.io.MalformedInputException</code> in such case.</p>
     *
     * @param fname Processing file name. null if the error occurs in document.
     * @param key Exception or String of error code.
     * @see com.ibm.xml.parser.Stderr#error(java.lang.String,int,int,java.lang.Object,String)
     */
    public void error(String fname, int lineno, int charoff, Object key, String mes);
}
