/*
 *  This source is originated from W3C DOM draft
 *     http://www.w3.org/TR/WD-DOM/level-one-core-971209.html
 *
 *  Copyright (C) 1997 W3C (MIT, INRIA, Keio).
 */

package org.w3c.dom;

public interface Node {

  public static final class NodeType {
    public static final int DOCUMENT 	= 0;
    public static final int ELEMENT 	= 1;
    public static final int ATTRIBUTE 	= 2;
    public static final int PI 		= 3;
    public static final int COMMENT 	= 4;
    public static final int TEXT 		= 5;
  };

  // getNodeType() returns one of the NodeType constants
  // defined above.

  int getNodeType();

  Node     getParentNode();
  NodeList getChildren();
  boolean  hasChildren();
  Node     getFirstChild();
  Node     getPreviousSibling();
  Node     getNextSibling();

  void insertBefore(Node newChild, Node refChild)
    throws NotMyChildException;

  Node replaceChild(Node oldChild, Node newChild)
    throws NotMyChildException;

  Node removeChild(Node oldChild)
    throws NotMyChildException;
};
